#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
#include <iomanip>
using namespace std;

#include "MaticaObdlznikova.h"
#include "MaticaStvorcova.h"
//---------------------------------------------------------------------------
// This is a default constructor to initiate the base class 'TMaticaStvorcova' 
// for childs
TMaticaStvorcova::TMaticaStvorcova()
{
	Matica = NULL; // dolezite
}
//---------------------------------------------------------------------------
//Konstruktor dynamicky alokuje pamat pre prvky matice a inicializuje ich
TMaticaStvorcova::TMaticaStvorcova(const unsigned n)
{
	unsigned i,j;

	PocetRiadkov = n;
	PocetStlpcov = n;

	Matica = new long double*[PocetRiadkov];         // pocet [] a * je 3
	for (i=0;i<PocetRiadkov;i++)
		Matica[i] = new long double[PocetStlpcov];    // pocet [] je 3

	for (i=0; i<PocetRiadkov; i++)
		for (j=0; j<PocetStlpcov; j++)
			Matica[i][j]=0;
}
//---------------------------------------------------------------------------
//Kopirovaci konstruktor
TMaticaStvorcova::TMaticaStvorcova(TMaticaStvorcova& X)
{
	unsigned i,j;

	PocetRiadkov = X.PocetRiadkov;
	PocetStlpcov = X.PocetStlpcov;

	Matica = new long double*[PocetRiadkov];         // pocet [] a * je 3
	for (i=0;i<PocetRiadkov;i++)
		Matica[i] = new long double[PocetStlpcov];    // pocet [] je 3

	for (i=0;i<PocetRiadkov;i++)
		for (j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.Matica[i][j];
}
//---------------------------------------------------------------------------
//Destruktor upratuje alokovanu pamat
TMaticaStvorcova::~TMaticaStvorcova()
{
	if (Matica != NULL) {
		for (unsigned i=0;i<PocetRiadkov;i++)
			delete[] Matica[i];
		delete[] Matica;
		Matica = NULL;
	}
}
//---------------------------------------------------------------------------
TMaticaStvorcova& TMaticaStvorcova::operator=(const TMaticaStvorcova& X)
{
	if (this == &X) return *this;

	for (unsigned i=0;i<PocetRiadkov;i++)
		for (unsigned j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.Matica[i][j];

	return *this;
}
//---------------------------------------------------------------------------
// Ak mame C = A + B a A a B su stvorcove matice, potom A + B je obdlznikova matica,
// zatial co C je stvorcova matica. Preto potrebujeme nasledujuce pretazenie:
TMaticaStvorcova& TMaticaStvorcova::operator=(const TMaticaObdlznikova& X)
{
	if (this == &X) return *this;

	my_class xx;

	if (X.getPocetRiadkov() != X.getPocetStlpcov()){
		cout << "\nTato obdlznikova matica sa neda previest na stvorcovu!";
		xx.my_getch();
		exit(1);
	}

	for (unsigned i=0;i<PocetRiadkov;i++)
		for (unsigned j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.getPrvokMatice(i,j);

	return *this;
}
//---------------------------------------------------------------------------
TMaticaStvorcova TMaticaStvorcova::UmocniMaticu(unsigned k)
{
	TMaticaStvorcova Y(PocetRiadkov), PomMatica0(PocetRiadkov), 
		PomMatica(PocetRiadkov);

	switch (k) {
	case 0:
		for (unsigned i = 0; i<PocetRiadkov; i++) {
			for (unsigned j = 0; j<PocetRiadkov; j++)
				Y.Matica[i][j] = 0;
			Y.Matica[i][i] = 1;
		}
		break;
	case 1:
		Y = *this;
		break;
	default:
		PomMatica0 = PomMatica = *this;
		k--;
		while (k--) {
			Y = PomMatica * PomMatica0;
			PomMatica = Y;
		}
	}

	return Y;
}
//---------------------------------------------------------------------------

