#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
#include <iomanip>
using namespace std;

#include "MaticaObdlznikova.h"
#include "MaticaStvorcova.h"
#include "CisloKomplexne.h"
#include "MaticaStvorcovaKomplexna.h"
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna::TMaticaStvorcovaKomplexna()
{
	MaticaKomplexna = NULL;
}
//---------------------------------------------------------------------------
//Konstruktor dynamicky alokuje pamat pre prvky matice a inicializuje ich
TMaticaStvorcovaKomplexna::TMaticaStvorcovaKomplexna(const unsigned n)
{
	unsigned i,j;
	TCisloKomplexne zero(0,0);

	PocetRiadkov = PocetStlpcov = n;

	MaticaKomplexna = new TCisloKomplexne*[PocetRiadkov];         // pocet [] a * je 3
	for (i=0;i<PocetRiadkov;i++)
		MaticaKomplexna[i] = new TCisloKomplexne[PocetStlpcov];    // pocet [] je 3

	for (i=0; i<PocetRiadkov; i++)
		for (j=0; j<PocetStlpcov; j++)
			MaticaKomplexna[i][j]=zero;
}
//---------------------------------------------------------------------------
//Kopirovaci konstruktor
TMaticaStvorcovaKomplexna::TMaticaStvorcovaKomplexna(TMaticaStvorcovaKomplexna& X)
{
	unsigned i,j;

	PocetRiadkov = X.PocetRiadkov;
	PocetStlpcov = X.PocetStlpcov;

	MaticaKomplexna = new TCisloKomplexne*[PocetRiadkov];         // pocet [] a * je 3
	for (i=0;i<PocetRiadkov;i++)
		MaticaKomplexna[i] = new TCisloKomplexne[PocetStlpcov];    // pocet [] je 3

	for (i=0;i<PocetRiadkov;i++)
		for (j=0;j<PocetStlpcov;j++)
			MaticaKomplexna[i][j] = X.MaticaKomplexna[i][j];
}
//---------------------------------------------------------------------------
//Destruktor upratuje alokovanu pamat
TMaticaStvorcovaKomplexna::~TMaticaStvorcovaKomplexna()
{
	if (MaticaKomplexna != NULL) {
		for (unsigned i = 0; i < PocetRiadkov; i++)
			delete[] MaticaKomplexna[i];
		delete[] MaticaKomplexna;
		MaticaKomplexna = NULL;
	}
}
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna& TMaticaStvorcovaKomplexna::operator=
	(const TMaticaStvorcovaKomplexna& X)
{
	if (this == &X) return *this;

	for (unsigned i=0;i<PocetRiadkov;i++)
		for (unsigned j=0;j<PocetStlpcov;j++)
			MaticaKomplexna[i][j] = X.MaticaKomplexna[i][j];

	return *this;
}
//---------------------------------------------------------------------------
const TMaticaStvorcovaKomplexna operator+(const TMaticaStvorcovaKomplexna& 
	LavaMatica,const TMaticaStvorcovaKomplexna& PravaMatica)
{
	TMaticaStvorcovaKomplexna VyslMatica(LavaMatica.PocetRiadkov);

	for (unsigned i=0; i<LavaMatica.PocetRiadkov; i++)
		for (unsigned j=0; j<LavaMatica.PocetStlpcov; j++)
			VyslMatica.MaticaKomplexna[i][j] = LavaMatica.MaticaKomplexna[i][j]
			+PravaMatica.MaticaKomplexna[i][j];

	return VyslMatica;
}
//---------------------------------------------------------------------------
const TMaticaStvorcovaKomplexna operator*(const TMaticaStvorcovaKomplexna& 
	LavaMatica,const TMaticaStvorcovaKomplexna& PravaMatica)
{
	TMaticaStvorcovaKomplexna VyslMatica(LavaMatica.PocetRiadkov);
	my_class xx;
	unsigned i,j,k;
	TCisloKomplexne Suma(0,0);

	if (LavaMatica.PocetStlpcov!=PravaMatica.PocetRiadkov){
		cout << "\nMatice sa nedaju nasobit!";
		xx.my_getch();
		exit(1);
	}

	for (i=0; i<LavaMatica.PocetRiadkov; i++)
		for (j=0; j<PravaMatica.PocetStlpcov; j++){
			for (k=0; k<LavaMatica.PocetStlpcov; k++) {
				Suma = Suma + LavaMatica.MaticaKomplexna[i][k] 
					* PravaMatica.MaticaKomplexna[k][j];
/*		Suma.Re = Suma.Re
		+ LavaMatica.MaticaKomplexna[i][k].Re * PravaMatica.MaticaKomplexna[k][j].Re
		- LavaMatica.MaticaKomplexna[i][k].Im * PravaMatica.MaticaKomplexna[k][j].Im;
		Suma.Im = Suma.Im
		+ LavaMatica.MaticaKomplexna[i][k].Re * PravaMatica.MaticaKomplexna[k][j].Im
		+ LavaMatica.MaticaKomplexna[i][k].Im * PravaMatica.MaticaKomplexna[k][j].Re; 
*/
			}
			VyslMatica.MaticaKomplexna[i][j]=Suma;
		}

	return VyslMatica;
}
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna& TMaticaStvorcovaKomplexna::operator+=
	(const TMaticaStvorcovaKomplexna& PravaMatica)
{
	*this = *this + PravaMatica;
	return *this;
}
//---------------------------------------------------------------------------
TMaticaStvorcovaKomplexna& TMaticaStvorcovaKomplexna::operator*=
	(const TMaticaStvorcovaKomplexna& PravaMatica)
{
	*this = *this * PravaMatica;
	return *this;
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is,TMaticaStvorcovaKomplexna& X)
{
	my_class xx;

	for (unsigned i=0;i<X.PocetRiadkov;i++)
		for (unsigned j=0;j<X.PocetStlpcov;j++)
			is >> X.MaticaKomplexna[i][j];
	if (is.fail()){
		cout << "Subor MaticaKomplexna.TXT sa nepodarilo otvorit.";
		xx.my_getch();
		exit(1);
	}

	return is;
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os,const TMaticaStvorcovaKomplexna& X)
{
	os.setf(ios::fixed,ios::floatfield);
	os.precision(2);
	for (unsigned i=0;i<X.PocetRiadkov;i++) {
		os << "\n  ";
		for (unsigned j=0;j<X.PocetStlpcov;j++)
			os << X.MaticaKomplexna[i][j] << "   ";
	}
	os << "\n";

	return os;
}
//---------------------------------------------------------------------------
void not_child_class::not_child_method()
{
//	TMaticaStvorcovaKomplexna A,zero(0, 0);
//	A = zero;
}
//---------------------------------------------------------------------------

