// new2.cpp
//
// Operator new pretizeny jako metoda
//
// Typ strela predstavuje strelu v nejake pocitacove hre.
// Strel je mnoho, ale ziji jen kratce, proto se nechceme zatezovat jejich
// alokaci z volne pameti a naslednym uvolnovanim. Strely alokujeme v arene, poli
// o dostatecne velikosti, ve kterem se ukladaji jedna za druhou a 
// po vycerpani kapacity areny zase od pocatku. Pritom doufame, ze strely, 
// ktere takto prepiseme, uz davno neexistuji. K tomu si definujeme zvlastni operator
// new jako metodu typu strela.

#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stddef.h>
#include <iostream>
using namespace std;

class strela {
	enum { pocet = 1000 };	// Maximalni pocet strel
	double x, y, rychlost;

	static char arena[];	// Pole pro alokaci strel
	static int index;		// Prubezny index pro alokaci strel
	static const int velikost; // Velikost 1 strely v bajtech
public:
	strela(double xx = 0, double yy = 0, double rr = 0)	// Konstruktor
		:x(xx), y(yy), rychlost(rr) {}
	void let();
	void* operator new(size_t s);		// Operator new, ktery alokuje strely do areny
	void* operator new[](size_t s);	// Polni verze operatoru new
};

void* strela::operator new(size_t s)
{
	int i = index;
	index += (int)s;
	if (index < pocet * velikost)
		return &arena[i];
	else if (index == pocet * velikost)
	{
		index = 0;
		return &arena[i];
	}
	else
	{
		index = 0;
		return arena;
	}
}

char strela::arena[pocet * sizeof(strela)];	// Deklarace statickych slozek
int strela::index = 0;
const int strela::velikost = sizeof(strela);

void* strela::operator new[](size_t s)
{
	return operator new(s);
}

void my_getch();

int main()
{
	for (int i = 0; i < 10; i++)					// Priklad pouziti
	{
		strela* u = new strela;
		cout << endl << u << endl;             // 1 strela = 24 bytov
	}
	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
